import { Input, Component } from 'angular-ts-decorators';
import { CorTableComponent } from './cor-table.component';

/**
 * Defines a column (optionally sortable) in the table.
 */
@Component({
  selector: 'corTableCol',
  template: '',
  require: {
    parent: '^^corTable'
  },
})
export class CorTableColumn implements ng.IComponentController {
  @Input('@') public title: string;
  @Input('@') public templateurl: string;

  @Input('@') public datafield: string;
  @Input('@') public sortfield: string;
  @Input('@') public selected: string;
  @Input('@') public dataKind: string;

  private parent: CorTableComponent;

  public $onInit(): void {
    this.parent.addColumn(this);
  }

  public isNumeric(): boolean {
    return this.dataKind == 'datetime';
  }

  public processColumnForOrdered(tableService: any, value: any): any {
    if (this.dataKind == 'datetime') {
       return tableService.getReversedTimestamp(value);
    }

    return value;
  }
}
